/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth W. Preslan <kpreslan@lcse.umn.edu>
** 
**    Module name: fs.h
**
*******************************************************************************
******************************************************************************/

#ifndef __FS_DOT_H__
#define __FS_DOT_H__

uint64 gfs_ino2gl(gfs_sbd_t *sdp, uint64 ino);

gfs_inode_t *gfs_ihashlookup(gfs_sbd_t *sdp, uint64 ino);
int gfs_ihashadd(gfs_inode_t *ip);
int gfs_ihashdel(gfs_inode_t *ip);

gfs_blklist_t *gfs_difree(gfs_inode_t *ip);

uint32 gfs_random(void);
uint32 gfs_randrange(uint32 low, uint32 high);

int gfs_change_nlink(gfs_inode_t *ip, int diff);

int gfs_truncate(gfs_inode_t *ip, uint64 length, gfs_blklist_t **blks);

#endif  /*  __FS_DOT_H__  */
