/******************************************************************************
*******************************************************************************
**
**    Copyright 1999 Sistina Software, Inc.  <kpreslan@sistina.com>
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth W. Preslan <kpreslan@sistina.com>
** 
**    Module name: dlock094.h
**
*******************************************************************************
******************************************************************************/

#ifndef DLOCK094_DOT_H
#define DLOCK094_DOT_H

#include <linux/net.h>
#include <linux/locks.h>
#include <linux/fs.h>

#include "global.h"
#include "gfs_locking.h"



#ifdef ASSERT
#undef ASSERT
#endif  /*  ASSERT  */
#define ASSERT(x) {if (!(x)) { \
		   printk(KERN_EMERG "\n\nYou've found a bug in dlock-0.9.4!\n\n"); \
		   printk(KERN_EMERG "Please copy down the following line and send it to gfs-devel@lcse.umn.edu\n\n"); \
		   panic("dlock-0.9.4:  Assertion \"%s\" failed on line %d of file %s\n", #x, \
			 __LINE__, __FILE__); } }



typedef struct dlock094_s
{
  char table_name[GFS_LOCKNAME_LEN + 1];

  gfs_callback_t *cb;
  void *fsdata;

  struct dentry *dcache;
  struct inode *inode;

  uint32 clientid;
  unsigned short port;

  struct socket *send_sock, *recv_sock;
  struct semaphore send_lock;

  struct semaphore recvd_lock;
  int recvd_stop;

  struct dlock094_s *next;
} dlock094_t;


#endif  /*  DLOCK094_DOT_H  */
