/******************************************************************************
*******************************************************************************
**
**    Copyright 1999 Sistina Software, Inc.  <kpreslan@sistina.com>
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Kenneth W. Preslan <kpreslan@sistina.com>
** 
**    Module name: main.c
**
*******************************************************************************
******************************************************************************/

#define __NO_VERSION__ 
#include <linux/module.h>
#include <linux/version.h>
char kernel_version [] = UTS_RELEASE;

#include "gfs_locking.h"
#include "lockops.h"





gfs_lock_proto_t dlock094_lock_proto =
{
  "dlock-0.9.4",
  dlock094_mount,
  dlock094_unmount,
  dlock094_lock,
  dlock094_unlock,
  dlock094_release,
  NULL
};


/******************************************************************************
*******************************************************************************
**
** init_module()
**
** Description:
**
** Input(s):
**
** Output(s):
**
** Returns:
**
*******************************************************************************
******************************************************************************/

int init_module(void)
{
  int error;

  if ((error = register_lock_proto(&dlock094_lock_proto)) < 0)
    return(error);

  return(0);
}


/******************************************************************************
*******************************************************************************
**
** cleanup_module()
**
** Description:
**
** Input(s):
**
** Output(s):
**
** Returns:
**
*******************************************************************************
******************************************************************************/

void cleanup_module(void)
{
  unregister_lock_proto(&dlock094_lock_proto);
}



/*  Symbols  */
EXPORT_NO_SYMBOLS;


