/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Manish M. Agarwal <agarwal@lcse.umn.edu>
** 
**    Module name:  gfs_balancer.h
**
*******************************************************************************
******************************************************************************/

#ifndef __GFS_BALANCER_DOT_H__
#define __GFS_BALANCER_DOT_H__

#define GFS_ABS(x)			(  ((x) > 0) ? (x) : (-(x))  )


/* Defines the accuracy with which the load balancer would balance the SPs */
#define GFS_LOAD_MARGIN		(0.05)


/* file size threshold for the filesystem balancer */
#define	GFS_MINFILESIZE  	(1<<15)


/* Maximum number of files that should be considered simultaneously by the 
   file system balancer */
#define GFS_MAX_FILES		(50)


/* Indicates how full the subpool is i.e. at average, above or below */
#define GFS_AVG			(0)
#define GFS_ABOVE		(1)
#define GFS_BELOW		(2)


/* Error List */
#define GFS_NOT_FOUND		1
#define GFS_DONE		3


/*
 * Structures. 
 */

typedef struct gfs_spdat_s
{
  uint32 	     spnum;
  uint64 	     nblks; /* the change in fract required */
  struct gfs_spdat_s *next; /* linked list ptr */
} gfs_spdat_t;

typedef struct gfs_fdat_s
{
  char  	    *fname;
  uint64	    blks;
  struct gfs_fdat_s *next;  /* linked list ptr */
} gfs_fdat_t;



#endif  /*  __GFS_IOCTL_DOT_H__  */
