#ifndef __DLOCK_CDB_C__
#define __DLOCK_CDB_C__

#include "dlock_CDB.h"




dlock_cdb *new_dlock_cdb(){
  dlock_cdb *cdb;
  cdb=(dlock_cdb *)malloc(sizeof(dlock_cdb));
  cdb->opcode=              0x83;
  cdb->action=                 0;
  cdb->lock_number=            0;
  cdb->input_version_number=   0;
  cdb->allocation_length=      0;
  cdb->cid=                    0;
  return(cdb);
}


cid_entry *new_cid_entry_(){
  cid_entry *cidn;
  cidn=(cid_entry *)malloc(sizeof(cid_entry));
  cidn->next=NULL;
  return(cidn);}

cid_entry *new_cid_entry(uint32 entry){
  cid_entry *cidn;
  cidn=(cid_entry *)malloc(sizeof(cid_entry));
  cidn->next=NULL;
  cidn->cid=entry;
  return(cidn);}

dlock_rdf *new_dlock_rdf(){
  dlock_rdf *rdf;
  rdf=(dlock_rdf *)malloc(sizeof(dlock_rdf));
  rdf->head=        NULL;
  rdf->result=         0;
  rdf->act=            0;
  rdf->expired=        0;
  rdf->state=          0;
  rdf->version_number= 0;
  rdf->num_holders=    0;
  return(rdf);
}

/*functions for adding, looking-up, and removing client ids
  from a dlock_rdf. */
void add_cid_entry_(dlock_rdf *rdf, cid_entry *entry){
  entry->next=rdf->head;
  rdf->head=entry;
  rdf->num_holders++;
/*   //dbprintf("add_cid rdf:%d\n",entry->cid); */
}

void add_cid_entry(dlock_rdf *rdf, uint32 entry){
 cid_entry *cide;
 cide=new_cid_entry_();
 cide->cid=entry;
 cide->next=rdf->head;
 rdf->head=cide;
 rdf->num_holders++;
/*  //dbprintf("add_cid rdf:%d\n",cide->cid); */
}

void clr_cid_entry(dlock_rdf *rdf){
  while(rdf->head!=NULL){
    rem_cid_entry(rdf, get_cid_entry(rdf, 0));
  }
  if(rdf->head!=NULL){
    dbprintf("uncleared%d\n", rdf->head->cid);
  }
}

void rem_cid_entry(dlock_rdf *rdf, uint32 entry){
  cid_entry *cid1, *cid2;
  int i=1;

  if(rdf->head==NULL){
    dbprintf("can't remove, head==NULL\n");
  }   /*do nothing if list is empty*/
  else if(rdf->head->cid==entry){/*remove first element*/
    cid1=rdf->head;
    rdf->head=rdf->head->next;
    free(cid1);
/*     //dbprintf("removed head rdf "); */
  }  /*free the memory*/
  else{
    cid1=rdf->head->next;
    cid2=rdf->head;
  
    while(cid1!=NULL){
      if(cid1->cid==entry){ 
	cid2->next=cid1->next;
	free(cid1);
/* 	//dbprintf("removed entry#%d rdf ", i); */
	return;}
      i++;
      cid2=cid1;    /*move through the list cid2 follows cid1*/
      cid1=cid1->next;
    }
  }
}

uint32 get_cid_entry(dlock_rdf *rdf, int ii){
  cid_entry *cide;
  int jj;
  uint32 gg;
  cide=rdf->head;
  for(jj=0;jj<ii;jj++){
    cide=cide->next;}
  gg=cide->cid;
  return(gg);
}



#endif /* __DLOCK_CDB_C__ */

