/* It has become much to difficult to try and build code in the kernel that
 * will interperate the normal xdr functions.  So I am going to attempt to
 * build them entirily by hand.
 *
 * Wish me luck.
 *
 * WARNING: The xdr functions for the RDF are only one way! This breaks the
 * requirements for xdr functions. If you try to use this for receiving
 * RDFs chaos will occure!
 */

#include <rpc/types.h>
#include <rpc/xdr.h>
#include <assert.h>
#include "nddserv.h"

/* ok, the CDB works just fine, so I'll copy that.
 * except I'm taking out the need for the simple u# -> u_int stuff
 */
bool_t
xdr_dlock_CDB(XDR *xdrs, dlock_CDB *objp)
{



	 if (!xdr_u_char(xdrs, (u_char*)&objp->opcode)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->action)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->lock_number)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->input_version_number)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->allocation_length)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->cid)) {
		 return (FALSE);
	 }
	return (TRUE);
}

bool_t
xdr_mode_CDB(XDR *xdrs, mode_CDB *objp)
{



	 if (!xdr_u_char(xdrs, (u_char*)&objp->tag)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->max_clients)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->num_locks)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->lock_time_ms)) {
		 return (FALSE);
	 }
	return (TRUE);
}

bool_t
xdr_CDBs(XDR *xdrs, CDBs *objp)
{



	 if (!xdr_int(xdrs, &objp->type)) {
		 return (FALSE);
	 }
	switch (objp->type) {
	case 0:
		 if (!xdr_dlock_CDB(xdrs, &objp->CDBs_u.dlock)) {
			 return (FALSE);
		 }
		break;
	case 1:
		 if (!xdr_mode_CDB(xdrs, &objp->CDBs_u.mode)) {
			 return (FALSE);
		 }
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}

/* Now on to the hard stuff. The RDF.  I'm going to keep the first level of
 * abstraction, so there's four xdr funcs down here.  The first is just a
 * selectcase.
 */

bool_t
xdr_dlock_RDF(XDR *xdrs, dlock_RDF *objp)
{
    struct cid_ntry *tmp;
    int kk=0;

#if 0
	 if (!xdr_u_short(xdrs, (u_short*)&objp->return_data_length)) {
		 return (FALSE);
	 }
#endif
	 if (!xdr_u_char(xdrs, (u_char*)&objp->result)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->act)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->expired)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->state)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->version_number)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->num_holders)) {
		 return (FALSE);
	 }
	 /* while loop to push the entire LL into the xdr
	  * WARNING: This will NOT decode this structure!
	  */
	 tmp = objp->head;
	 while(tmp != NULL) {
	   kk++;
	   assert(kk<=objp->num_holders);
	   xdr_u_int(xdrs, (u_int*)&tmp->cid);
	   tmp = tmp->next;
	 }
	return (TRUE);
}

bool_t
xdr_rexpired_RDF(XDR *xdrs, rexpired_RDF *objp)
{



	 /* xdr_array send the length for us */
	 if (!xdr_array(xdrs, (char **)&objp->exlock_block,
				(u_int *)&objp->return_length, ~0, sizeof(u8), 
				(xdrproc_t)xdr_u_char)) {
		 return (FALSE);
	 }
	return (TRUE);
}

/* the second type is simple. */
bool_t
xdr_mode_page_RDF(XDR *xdrs, mode_page_RDF *objp)
{



	 if (!xdr_u_int(xdrs, (u_int*)&objp->num_locks)) {
		 return (FALSE);
	 }
	 if (!xdr_u_char(xdrs, (u_char*)&objp->max_clients)) {
		 return (FALSE);
	 }
	 if (!xdr_u_int(xdrs, (u_int*)&objp->lock_time_ms)) {
		 return (FALSE);
	 }
	return (TRUE);
}


/* The selector for the three type.
 */
bool_t
xdr_RDFs(XDR *xdrs, RDFs *objp)
{



	 if (!xdr_int(xdrs, &objp->type)) {
		 return (FALSE);
	 }
	switch (objp->type) {
	case 0:
		 if (!xdr_dlock_RDF(xdrs, &objp->RDFs_u.dlock)) {
			 return (FALSE);
		 }
		break;
	case 1:
		 if (!xdr_rexpired_RDF(xdrs, &objp->RDFs_u.rex)) {
			 return (FALSE);
		 }
		break;
	case 2:
		 if (!xdr_mode_page_RDF(xdrs, &objp->RDFs_u.mpag)) {
			 return (FALSE);
		 }
		break;
	default:
		return (FALSE);
	}
	return (TRUE);
}
