#ifndef __PARTITION_C__
#define __PARTITION_C__

#include "partition.h"


server_dlock *new_server_dlock(){
  server_dlock *sdl;
  sdl=(server_dlock *)malloc(sizeof(server_dlock));
  sdl->version_number=0;
  sdl->state=STATE_UNLOCKED;
  sdl->act=ACTIVITY_OFF;
  sdl->num_holders=0;
  sdl->expired=EXPIRED_NOT;
  sdl->exclusive_pending=EXCLUSIVE_NOT_PENDING;
  sdl->expire_time=0;
  sdl->head=NULL;
  return(sdl);
}

void delete_server_dlock(server_dlock *sdl){
  sdl_clear_cid(sdl);
  free(sdl);
}

cid_entry *get_cid_list(int i, server_dlock *sdl){
  cid_entry *cid;
  int j;

  
  if(i>sdl->num_holders){
 /*   //dbprintf("i=%d, hum_holders=%d ", i, sdl->num_holders); */
    return(NULL);}
  else{
    cid=sdl->head;
    for(j=0;j< i; j++){
      /*dbprintf(".");*/
      cid=cid->next;}
    /*dbprintf("getting %d, =%d   ", i, cid->cid);*/
    return(cid);
  }
}

int get_cid_index(uint32 lookup, server_dlock *sdl){
  cid_entry *cid;
  int i;

  cid=sdl->head;
  if(cid==NULL){
    return(-1);
    dbprintf("fuck\n\n\n");}
  else{
    for(i=0;i<sdl->num_holders; i++){
      if(cid==NULL){
	return(-1);
	printf("fuck\n\n\n");}
      if(cid->cid==lookup){
	return i;
      }
      cid=cid->next;
    }
    return(-1);
  }
}
/********************************************************
 *object oriented emulation functions.
 ********************************************************/
void sdl_reset       (server_dlock *sdl){
  time_t *tttp, ttt;
  tttp=NULL;
  ttt=time(tttp);
  sdl->expire_time=(EXPIRE_TIME + (int)ttt);
}

void sdl_clear_cid   (server_dlock *sdl){
  int i;
  cid_entry *cidn;
  cidn=sdl->head;
/*   //printf(" p:clearcid"); */
  for(i=0; i<sdl->num_holders; i++){
    cidn=sdl->head;
    if(cidn==NULL)
      return;
    sdl->head=sdl->head->next;
    free(cidn);
  }
  sdl->num_holders=0;
  if(sdl->head==NULL){
 /*    //printf("p:c_c "); */
  }
  return;
}


/**********************************************************
 *returns true if a particular cid is a holder of the lock
 **********************************************************/
int cid_in_dlock(server_dlock *sdl, uint32 lookup){
  int i;
  
/*   //printf("cidindl"); */
  i=get_cid_index(lookup, sdl);
  if(i==-1){
    return 0;
  }
  else
    return 1;
}

/**********************************************************
 *removes a holder from the holder array, decrements the length
 **********************************************************/
int rem_dlock_cid(server_dlock *sdl, uint32 rem){
  cid_entry *cid1, *cid2;
  int i=1;

  if(sdl->head==NULL){
    return(-1);
/*     //dbprintf(" p:head is null, can't remove. \n"); */
  }   /*do nothing if list is empty*/
  else if(sdl->head->cid==rem){/*remove first element*/
/*     //dbprintf(" p:removed head\n"); */
    cid1=sdl->head;
    sdl->head=sdl->head->next;
    free(cid1);
    sdl->num_holders--;
    return 1;
 }  /*free the memory*/
  else{
    cid1=sdl->head->next;
    cid2=sdl->head;
    while(cid1!=NULL){
      if(cid1->cid==rem){ 
/* 	//dbprintf(" p:removing %d. \n", i); */
	cid2->next=cid1->next;
	free(cid1);
	sdl->num_holders--;
	return 1;}
      cid2=cid1;    /*move through the list cid2 follows cid1*/
      cid1=cid1->next;
      i++;
    }
    return(-1);
  }
}


/**********************************************************
 *adds a holder into the array of holders. increments length
 **********************************************************/
int add_dlock_cid(server_dlock *sdl, uint32 add){
  cid_entry *cide;

  cide=new_cid_entry_();
  cide->cid=add;
  cide->next=sdl->head;
  sdl->head=cide;
  sdl->num_holders++;
/*   //dbprintf("add_cid sdl:%d \n",cide->cid);  */

  return(1);
}


partition_locks *new_partition_locks(int numlocks){
  partition_locks *pal;
  int                     i;

  pal=(partition_locks *)malloc(sizeof(partition_locks));
  pal->dlocks_per_partition=numlocks;
  pal->lock_timeout_interval=EXPIRE_TIME;
  pal->max_lock_holds=MAX_LOCK_HOLDS;


  pal->sdl=(server_dlock **)malloc(numlocks*sizeof(server_dlock *));  
  for(i=0; i<numlocks; i++){
    pal->sdl[i]=new_server_dlock();
    pal->sdl[i]->lock_number=(uint32)i;
  }
  return(pal);
}

void delete_partition_locks(partition_locks *pal){
  int i;
  
  for(i=0; i<pal->dlocks_per_partition; i++){
    delete_server_dlock(pal->sdl[i]);}
  free(pal);
}




#endif /* __PARTITION_C__ */
