
/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Andrew Barry <barry@lcse.umn.edu>
** 
**    Module name: memory.h
**
**    Description: This is only for bug fixing, it should not be released
**    with the final product. If you receive this with an official release
**    of the software, please inform the maintainer. 
**
*******************************************************************************
******************************************************************************/

#ifndef __MEMORY_H__
#define __MEMORY_H__

#include <stdlib.h>
#include <stdio.h>
#include <malloc.h>
#include <string.h>
#include <assert.h>


typedef struct memlist_s{
  int type;
  int count;
  void *start;
  int length;
  struct memlist_s *next;
}memlist_t;

#ifdef EXTERN
#define EXTERN
#define INIT(x) = x
#else 
#define EXTERN extern
#define INIT(x)
#endif  





EXTERN memlist_t *mem_list INIT(NULL);


/*static inline void *memlist_malloc(int x);
  static inline void memlist_free(void *data);
  static inline void print_memlist();*/

static /*inline*/ void *memlist_malloc(int x, int typ){
  void *data;
  memlist_t *ml;
  
  data = malloc(x);
  if (!data)
    return(NULL);
  
  ml = (memlist_t *)malloc(sizeof(memlist_t));
  assert(ml);


  ml->type = typ;


  ml->start = data;
  ml->length = x;
  
  ml->next = mem_list;
  mem_list = ml;
  printf(".");
  return(data);
}



static /*inline*/ void memlist_free(void *data){
  memlist_t *tmp, *last = NULL;

  printf(",");
  for (tmp = mem_list; tmp; last = tmp, tmp = tmp->next)
    if (tmp->start == data)
      break;

  if (!tmp){
    printf("Illegal free of address 0x%.8lX\n", (unsigned long)data);
    return;
  }

  if (tmp == mem_list){
    mem_list = mem_list->next;
    free(tmp);
  } 
  else{
    last->next = tmp->next;
    free(tmp);
  }
}



static /*inline*/ void print_memlist(){
  memlist_t *ml;

  for (ml = mem_list; ml; ml = ml->next)
    printf("start = 0x%.8lX, length = %u, type= %d\n",
           (unsigned long)ml->start, ml->length, ml->type);
}


/*#define malloc(x) memlist_malloc((x))*/
/*#define free(x) memlist_free((x))*/
#define exit(x) {print_memlist();exit((x));}









#endif /* __MEMORY_H__ */
