/******************************************************************************
*******************************************************************************
**
**    Copyright 1995-1999 Regents of the University of Minnesota
**
**    This is free software released under the GNU General Public License.
**    There is no warranty for this software.  See the file COPYING for
**    details.
**
**    See the file CONTRIBUTORS for a list of contributors.
**
**    This file is maintained by:
**      Andrew Barry <barry@lcse.umn.edu>
** 
**    Module name: partition_opps.h 
**
*******************************************************************************
******************************************************************************/


#ifndef __PARTITION_OPPS_H__
#define __PARTITION_OPPS_H__


#include <time.h>
#include "partition.h"
#include "print.h"
#include <sys/time.h>

/***************************************************
 ***************************************************
 **
 **for more information on the bahavior of these 
 **functions check partition_opps.c. 
 **
 ***************************************************
 ***************************************************/


/*function prototypes*/
void  mode_actions       (partition_locks *pal, mode_cdb  *cdb,
			  mode_page_rdf *rdf);
void  part_actions       (partition_locks *pal, dlock_cdb *cdb, 
			  dlock_rdf *rdf, send_req_t *sr);
void  expired_actions    (partition_locks *pal, dlock_cdb *cdb,
			  rexpired_rdf *exp);
/*sudo private function prototypes*/
void no_operation        (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void lock_shared         (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void lock_exclusive      (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void force_lock_exclusive(partition_locks *pal, dlock_cdb *cdb, 
			  dlock_rdf *rdf, send_req_t *sr);
void touch_lock          (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf,  send_req_t *sr);
void unlock              (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf,  send_req_t *sr);
void unlock_increment    (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void activity_on         (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void activity_off        (partition_locks *pal, dlock_cdb *cdb, 
		          dlock_rdf *rdf, send_req_t *sr);
void report_expired      (partition_locks *pal, dlock_cdb *cdb,
		          rexpired_rdf *exp);
void deal_expired        (partition_locks *pal, dlock_cdb *cdb,
		          dlock_rdf *rdf);
void all_actions         (partition_locks *pal, dlock_cdb *cdb, 
			  dlock_rdf *rdf);
void bad_lock_number     (partition_locks *pal, dlock_cdb *cdb, 
			  dlock_rdf *rdf);
int send_drop            (u32 lock_number, u32 flags, send_req_t *sr);


#endif /* __PARTITION_OPPS_H__ */
