#ifndef _STRUCTS_H
#define _STRUCTS_H

#define BUF_SIZE 1024
#define ARG_SIZE 256
#define NR_ARGS  10

/*
char buf[BUF_SIZE];
char arg[NR_ARGS][ARG_SIZE];
*/

extern char * action_names[];

enum action_t  { 
  NOP,
  LOCK_SHARED,
  LOCK_EXCL,
  FLE,
  REF_LOCK,
  UNLOCK,
  UNLOCK_INC,
  ACT_ON,
  ACT_OFF,
  REP_EXP,
  NR_ACTIONS
};


extern char * expired_names[];

enum expired_t {
  NOT_EXP,
  EXP_SHARED,
  EXP_EXCL,
  NR_EXPIREDS
};


extern char * state_names[];

enum state_t {
  UNLOCKED,
  LOCKED_SHARED,
  LOCKED_EXCL,
  NR_STATES
};


extern char * sect_names[];

enum sect_t {
  TEST,
  OP,
  RESULT,
  NR_SECTS
};


extern char * when_names[];

enum when_t {
  FOR_EACH,
  BEG,
  NR_WHENS
};


enum param_in_t {
  ACTION,
  LOCK,
  CLID,
  IVER,
  NR_PARAM_INS
};


extern char * param_out_names[];

enum param_out_t {
  RES,
  STATE,
  EXP,
  ACTIVITY,
  VER,
  HOLDERS,
  CLIDS
};


  
enum how_t {
  FIXED,
  LINEAR,
  RANDOM
};

typedef struct number_range {
  unsigned int base;
  int range;
  char how, init;
  int *this;
} number_range_t;

number_range_t param_in_range[NR_PARAM_INS];
 
typedef struct name_table {
  char **names;
  int nr_names;
} name_table_t;

extern name_table_t action_tab, expired_tab, state_tab, sect_tab;
extern name_table_t when_tab;

typedef struct prelim {
  int state;
  int when;
} prelim_t;

typedef struct param_out {
  int result, state, expired, activity, version, holders;
  int clientids[128];
} param_out_t;

typedef struct param_in {
  int action, locknum, clientid, inputversion;
} param_in_t;


typedef struct dlock_param_s
{
  /*  Parameters passed in  */

  int action, lock_num, cid, inp_ver;

  /*  Parameters passed back  */

  int res, state, exp, activity, ver, holders;
  int cids[128];
} dlock_param_t;

typedef struct dlock_param_alias {
  
  int action[4];
  int result[6];
  int cids[128];
} dlock_param_alias_t;


void suite_init();


/*
char * get_arg(int n);
int atoic(char *c);
void init();

void section_handler(int sect);
void test_handler();
void op_handler();
void result_handler();
*/

#endif

